OGRE: Ogre::v1::Entity Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | Friends | List of all members
Ogre::v1::Entity Class Reference
Core | Component » Scene

Defines an instance of a discrete, movable object based on a Mesh. More...

`#include <OgreEntity.h>`

Inheritance diagram for Ogre::v1::Entity:
[legend]

## Public Types
typedef set< Entity * >::type | EntitySet
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...
typedef map< unsigned short, bool >::type | SchemeHardwareAnimMap
enum | VertexDataBindChoice { BIND_ORIGINAL, BIND_SOFTWARE_SKELETAL, BIND_SOFTWARE_MORPH, BIND_HARDWARE_MORPH }
| Identify which vertex data we should be sending to the renderer. More...

## Public Member Functions
| ~Entity ()
| Default destructor. More...
void | _deinitialise (void)
| Tear down the internal structures of this Entity, rendering it uninitialised. More...
const Matrix4 * | _getBoneMatrices (void) const
| Internal method for retrieving bone matrix information. More...
bool | _getBuffersMarkedForAnimation (void) const
| Are buffers already marked as vertex animated? More...
VertexData * | _getHardwareVertexAnimVertexData (void) const
| Advanced method to get the hardware morph vertex information. More...
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
unsigned short | _getNumBoneMatrices (void) const
| Internal method for retrieving bone matrix information. More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
TempBlendedBufferInfo * | _getSkelAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software skeletal animation. More...
VertexData * | _getSkelAnimVertexData (void) const
| Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned. More...
VertexData * | _getSoftwareVertexAnimVertexData (void) const
| Advanced method to get the temporarily blended software vertex animation information. More...
TempBlendedBufferInfo * | _getVertexAnimTempBufferInfo (void)
| Advanced method to get the temp buffer information for software morph animation. More...
void | _initialise (bool forceReinitialise=false)
| Try to initialise the Entity from the underlying resources. More...
bool | _isAnimated (void) const
| Tests if any animation applied to this entity. More...
bool | _isSkeletonAnimated (void) const
| Tests if skeleton was animated. More...
void | _markBuffersUsedForAnimation (void)
| Mark just this vertex data as animated. More...
void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost. More...
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
void | _updateAnimation (void)
| Advanced method to perform all the updates required for an animated entity. More...
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addSoftwareAnimationRequest (bool normalsAlso)
| Add a request for software animation. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
TagPoint * | attachObjectToBone (const String &boneName, MovableObject *pMovable, const Quaternion &offsetOrientation=Quaternion::IDENTITY, const Vector3 &offsetPosition=Vector3::ZERO)
| Attaches another object to a certain bone of the skeleton which this entity uses. More...
VertexDataBindChoice | chooseVertexDataForBinding (bool hasVertexAnim)
| Choose which vertex data to bind to the renderer. More...
Entity * | clone (void) const
| Clones this entity and returns a pointer to the clone. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
void | detachAllObjectsFromBone (void)
| Detach all MovableObjects previously attached using attachObjectToBone. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
MovableObject * | detachObjectFromBone (const String &movableName)
| Detach a MovableObject previously attached using attachObjectToBone. More...
void | detachObjectFromBone (MovableObject *obj)
| Detaches an object by pointer. More...
AnimationStateSet * | getAllAnimationStates (void) const
| For entities based on animated meshes, gets the AnimationState objects for all animations. More...
bool | getAlwaysUpdateMainSkeleton () const
| The skeleton of the main entity will be updated even if the an LOD entity is being displayed. More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
AnimationState * | getAnimationState (const String &name) const
| For entities based on animated meshes, gets the AnimationState object for a single animation. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
unsigned char | getCurrentMeshLod (void) const
bool | getDisplaySkeleton (void) const
| Returns whether or not the entity is currently displaying its skeleton. More...
EdgeData * | getEdgeList (void)
IdType | getId () const
| Get the unique id of this object. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
Entity * | getManualLodLevel (size_t index) const
| Gets a pointer to the entity representing the numbered manual level of detail. More...
const MeshPtr & | getMesh (void) const
| Gets the Mesh that this Entity is based on. More...
const String & | getMovableType (void) const
| Returns the type name of this object. More...
const String & | getName (void) const
| Returns the name of this object. More...
size_t | getNumManualLodLevels (void) const
| Returns the number of manual levels of detail that this entity supports. More...
size_t | getNumSubEntities (void) const
| Retrieves the number of SubEntity objects making up this entity. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
OldSkeletonInstance * | getSkeleton (void) const
| Get this Entity's personal skeleton instance. More...
SkeletonInstance * | getSkeletonInstance (void) const
const EntitySet * | getSkeletonInstanceSharingSet () const
| Returns a pointer to the set of entities which share a OldSkeletonInstance. More...
bool | getSkipAnimationStateUpdate () const
| Entity's skeleton's AnimationState will not be automatically updated when set to true. More...
int | getSoftwareAnimationNormalsRequests (void) const
| Returns the number of requests that have been made for software animation of normals. More...
int | getSoftwareAnimationRequests (void) const
| Returns the number of requests that have been made for software animation. More...
SubEntity * | getSubEntity (const String &name)
| Gets a pointer to a SubEntity by name. More...
const SubEntity * | getSubEntity (const String &name) const
SubEntity * | getSubEntity (size_t index)
| Gets a pointer to a SubEntity, ie a part of an Entity. More...
const SubEntity * | getSubEntity (size_t index) const
uint32 | getTypeFlags (void) const
| Override to return specific type flag. More...
bool | getUpdateBoundingBoxFromSkeleton () const
| If true, the skeleton of the entity will be used to update the bounding box for culling. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
VertexData * | getVertexDataForBinding (bool casterPass)
| Retrieve the VertexData which should be used for GPU binding. More...
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
bool | hasAnimationState (const String &name) const
| Returns whether the AnimationState with the given name exists. More...
bool | hasEdgeList (void)
bool | hasSkeleton (void) const
| Returns whether or not this entity is skeletally animated. More...
bool | hasVertexAnimation (void) const
| Returns whether or not this entity is either morph or pose animated. More...
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
bool | isHardwareAnimationEnabled (void)
| Returns whether or not hardware animation is enabled. More...
bool | isInitialised (void) const
| Has this Entity been initialised yet? More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
virtual void | loadingComplete (Resource *)
| Called whenever the resource finishes loading. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
virtual void | preparingComplete (Resource *)
| Called whenever the resource finishes preparing (paging into memory). More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
void | refreshAvailableAnimationState (void)
| Updates the internal animation state set to include the latest available animations from the attached skeleton. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeSoftwareAnimationRequest (bool normalsAlso)
| Removes a request for software animation. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | setAlwaysUpdateMainSkeleton (bool update)
| The skeleton of the main entity will be updated even if the an LOD entity is being displayed. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
void | setDatablock (HlmsDatablock *datablock)
| Sets the given HLMS datablock to all SubEntities. More...
void | setDatablock (IdString datablockName)
| Sets the given HLMS datablock to all SubEntities. More...
void | setDatablockOrMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the material to use for the whole of this Item. More...
void | setDisplaySkeleton (bool display)
| Tells the Entity whether or not it should display it's skeleton, if it has one. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
void | setMaterial (const MaterialPtr &material)
| Sets the material to use for the whole of this entity. More...
void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the material to use for the whole of this entity. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
void | setPolygonModeOverrideable (bool PolygonModeOverrideable)
| Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings. More...
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
void | setRenderQueueGroup (uint8 queueID)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the RenderQueue subgroup ID for the whole of this entity. More...
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
void | setSkipAnimationStateUpdate (bool skip)
| Entity's skeleton's AnimationState will not be automatically updated when set to true. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
void | setUpdateBoundingBoxFromSkeleton (bool update)
| If true, the skeleton of the entity will be used to update the bounding box for culling. More...
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...
void | shareSkeletonInstanceWith (Entity *entity)
| Shares the OldSkeletonInstance with the supplied entity. More...
bool | sharesSkeletonInstance () const
| Returns whether this entity shares it's SkeltonInstance with other entity instances. More...
void | stopSharingSkeletonInstance ()
| Stops sharing the OldSkeletonInstance with other entities. More...
virtual void | unloadingComplete (Resource *)
| Called whenever the resource has been unloaded. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh

## Friends
class | EntityFactory
class | SubEntity

## Detailed Description

Defines an instance of a discrete, movable object based on a Mesh.

Remarks
  Ogre generally divides renderable objects into 2 groups, discrete (separate) and relatively small objects which move around the world, and large, sprawling geometry which makes up generally immovable scenery, aka 'level geometry'.

  The Mesh and SubMesh classes deal with the definition of the geometry used by discrete movable objects. Entities are actual instances of objects based on this geometry in the world. Therefore there is usually a single set Mesh for a car, but there may be multiple entities based on it in the world. Entities are able to override aspects of the Mesh it is defined by, such as changing material properties per instance (so you can have many cars using the same geometry but different textures for example). Because a Mesh is split into SubMeshes for this purpose, the Entity class is a grouping class (much like the Mesh class) and much of the detail regarding individual changes is kept in the SubEntity class. There is a 1:1 relationship between SubEntity instances and the SubMesh instances associated with the Mesh the Entity is based on.

  Entity and SubEntity classes are never created directly. Use the createEntity method of the SceneManager (passing a model name) to create one.

  Entities are included in the scene by associating them with a SceneNode, using the attachEntity method. See the SceneNode class for full information.

Note
  No functions were declared virtual to improve performance.

## Member Typedef Documentation

## ◆ EntitySet

typedef set<Entity*>::type Ogre::v1::Entity::EntitySet

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## ◆ SchemeHardwareAnimMap

typedef map<unsigned short, bool>::type Ogre::v1::Entity::SchemeHardwareAnimMap

## Member Enumeration Documentation

## ◆ VertexDataBindChoice

enum Ogre::v1::Entity::VertexDataBindChoice

Identify which vertex data we should be sending to the renderer.

Enumerator
BIND_ORIGINAL |
BIND_SOFTWARE_SKELETAL |
BIND_SOFTWARE_MORPH |
BIND_HARDWARE_MORPH |

## Constructor & Destructor Documentation

## ◆ ~Entity()

Ogre::v1::Entity::~Entity | ( |  | ) |

Default destructor.

## Member Function Documentation

## ◆ _deinitialise()

void Ogre::v1::Entity::_deinitialise | ( | void |  | ) |

Tear down the internal structures of this Entity, rendering it uninitialised.

## ◆ _getBoneMatrices()

const Matrix4* Ogre::v1::Entity::_getBoneMatrices | ( | void |  | ) | const
| inline

Internal method for retrieving bone matrix information.

## ◆ _getBuffersMarkedForAnimation()

bool Ogre::v1::Entity::_getBuffersMarkedForAnimation | ( | void |  | ) | const
| inline

Are buffers already marked as vertex animated?

## ◆ _getHardwareVertexAnimVertexData()

VertexData* Ogre::v1::Entity::_getHardwareVertexAnimVertexData | ( | void |  | ) | const

Advanced method to get the hardware morph vertex information.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getNumBoneMatrices()

unsigned short Ogre::v1::Entity::_getNumBoneMatrices | ( | void |  | ) | const
| inline

Internal method for retrieving bone matrix information.

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _getSkelAnimTempBufferInfo()

TempBlendedBufferInfo* Ogre::v1::Entity::_getSkelAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software skeletal animation.

## ◆ _getSkelAnimVertexData()

VertexData* Ogre::v1::Entity::_getSkelAnimVertexData | ( | void |  | ) | const

Advanced method to get the temporarily blended skeletal vertex information for entities which are software skinned.

Remarks
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getSoftwareVertexAnimVertexData()

VertexData* Ogre::v1::Entity::_getSoftwareVertexAnimVertexData | ( | void |  | ) | const

Advanced method to get the temporarily blended software vertex animation information.

Remarks
  Internal engine will eliminate software animation if possible, this information is unreliable unless added request for software animation via addSoftwareAnimationRequest.

Note
  The positions/normals of the returned vertex data is in object space.

## ◆ _getVertexAnimTempBufferInfo()

TempBlendedBufferInfo* Ogre::v1::Entity::_getVertexAnimTempBufferInfo | ( | void |  | ) |

Advanced method to get the temp buffer information for software morph animation.

## ◆ _initialise()

void Ogre::v1::Entity::_initialise | ( | bool | forceReinitialise = `false` | ) |

Try to initialise the Entity from the underlying resources.

Remarks
  This method builds the internal structures of the Entity based on it resources (Mesh, Skeleton). This may or may not succeed if the resources it references have been earmarked for background loading, so you should check isInitialised afterwards to see if it was successful.

Parameters

  forceReinitialise | If `true`, this forces the Entity to tear down it's internal structures and try to rebuild them. Useful if you changed the content of a Mesh or Skeleton at runtime.

## ◆ _isAnimated()

bool Ogre::v1::Entity::_isAnimated | ( | void |  | ) | const

Tests if any animation applied to this entity.

Remarks
  An entity is animated if any animation state is enabled, or any manual bone applied to the skeleton.

## ◆ _isSkeletonAnimated()

bool Ogre::v1::Entity::_isSkeletonAnimated | ( | void |  | ) | const

Tests if skeleton was animated.

## ◆ _markBuffersUsedForAnimation()

void Ogre::v1::Entity::_markBuffersUsedForAnimation | ( | void |  | ) |

Mark just this vertex data as animated.

## ◆ _notifyAttached()

void Ogre::v1::Entity::_notifyAttached | ( | Node * | parent | ) |
| virtual

Internal method called to notify the object that it has been attached to a node.

Reimplemented from Ogre::MovableObject.

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _releaseManualHardwareResources()

virtual void Ogre::MovableObject::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources were lost.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented in Ogre::v1::ManualObject, and Ogre::v1::BillboardSet.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _updateAnimation()

void Ogre::v1::Entity::_updateAnimation | ( | void |  | ) |

Advanced method to perform all the updates required for an animated entity.

Remarks
  You don't normally need to call this, but it's here in case you wish to manually update the animation of an Entity at a specific point in time. Animation will not be updated more than once a frame no matter how many times you call this method.

## ◆ _updateRenderQueue()

void Ogre::v1::Entity::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| virtual

Reimplemented from Ogre::MovableObject.

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addSoftwareAnimationRequest()

void Ogre::v1::Entity::addSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Add a request for software animation.

Remarks
  Tells the entity to perform animation calculations for skeletal/vertex animations in software, regardless of the current setting of isHardwareAnimationEnabled(). Software animation will be performed any time one or more requests have been made. If 'normalsAlso' is 'true', then the entity will also do software blending on normal vectors, in addition to positions. This advanced method useful for situations in which access to actual mesh vertices is required, such as accurate collision detection or certain advanced shading techniques. When software animation is no longer needed, the caller of this method should always remove the request by calling removeSoftwareAnimationRequest(), passing the same value for 'normalsAlso'.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ attachObjectToBone()

TagPoint* Ogre::v1::Entity::attachObjectToBone | ( | const String & | boneName,
|  | MovableObject * | pMovable,
|  | const Quaternion & | offsetOrientation = `Quaternion::IDENTITY`,
|  | const Vector3 & | offsetPosition = `Vector3::ZERO`
| ) |  |

Attaches another object to a certain bone of the skeleton which this entity uses.

Remarks
  This method can be used to attach another object to an animated part of this entity, by attaching it to a bone in the skeleton (with an offset if required). As this entity is animated, the attached object will move relative to the bone to which it is attached.

  An exception is thrown if the movable object is already attached to the bone, another bone or scenenode. If the entity has no skeleton or the bone name cannot be found then an exception is thrown.

Parameters

  boneName | The name of the bone (in the skeleton) to attach this object
  pMovable | Pointer to the object to attach
  offsetOrientation | An adjustment to the orientation of the attached object, relative to the bone.
  offsetPosition | An adjustment to the position of the attached object, relative to the bone.

Returns
  The TagPoint to which the object has been attached

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ chooseVertexDataForBinding()

VertexDataBindChoice Ogre::v1::Entity::chooseVertexDataForBinding | ( | bool | hasVertexAnim | ) |

Choose which vertex data to bind to the renderer.

## ◆ clone()

Entity* Ogre::v1::Entity::clone | ( | void |  | ) | const

Clones this entity and returns a pointer to the clone.

Remarks
  Useful method for duplicating an entity. The new entity must be given a unique name, and is not attached to the scene in any way so must be attached to a SceneNode to be visible (exactly as entities returned from SceneManager::createEntity).

Parameters

  newName | Name for the new entity.

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ detachAllObjectsFromBone()

void Ogre::v1::Entity::detachAllObjectsFromBone | ( | void |  | ) |

Detach all MovableObjects previously attached using attachObjectToBone.

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ detachObjectFromBone() [1/2]

MovableObject* Ogre::v1::Entity::detachObjectFromBone | ( | const String & | movableName | ) |

Detach a MovableObject previously attached using attachObjectToBone.

If the movable object name is not found then an exception is raised.

Parameters

  movableName | The name of the movable object to be detached.

## ◆ detachObjectFromBone() [2/2]

void Ogre::v1::Entity::detachObjectFromBone | ( | MovableObject * | obj | ) |

Detaches an object by pointer.

Remarks
  Use this method to destroy a MovableObject which is attached to a bone of belonging this entity. But sometimes the object may be not in the child object list because it is a LOD entity, this method can safely detect and ignore in this case and won't raise an exception.

## ◆ getAllAnimationStates()

AnimationStateSet* Ogre::v1::Entity::getAllAnimationStates | ( | void |  | ) | const

For entities based on animated meshes, gets the AnimationState objects for all animations.

Returns
  In case the entity is animated, this functions returns the pointer to a AnimationStateSet containing all animations of the entries. If the entity is not animated, it returns 0.

Remarks
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

## ◆ getAlwaysUpdateMainSkeleton()

bool Ogre::v1::Entity::getAlwaysUpdateMainSkeleton | ( |  | ) | const
| inline

The skeleton of the main entity will be updated even if the an LOD entity is being displayed.

useful if you have entities attached to the main entity. Otherwise position of attached entities will not be updated.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getAnimationState()

AnimationState* Ogre::v1::Entity::getAnimationState | ( | const String & | name | ) | const

For entities based on animated meshes, gets the AnimationState object for a single animation.

Remarks
  You animate an entity by updating the animation state objects. Each of these represents the current state of each animation available to the entity. The AnimationState objects are initialised from the Mesh object.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getDisplaySkeleton()

bool Ogre::v1::Entity::getDisplaySkeleton | ( | void |  | ) | const

Returns whether or not the entity is currently displaying its skeleton.

## ◆ getEdgeList()

EdgeData* Ogre::v1::Entity::getEdgeList | ( | void |  | ) |

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getManualLodLevel()

Entity* Ogre::v1::Entity::getManualLodLevel | ( | size_t | index | ) | const

Gets a pointer to the entity representing the numbered manual level of detail.

Remarks
  The zero-based index never includes the original entity, unlike Mesh::getLodLevel.

## ◆ getMesh()

const MeshPtr& Ogre::v1::Entity::getMesh | ( | void |  | ) | const

Gets the Mesh that this Entity is based on.

## ◆ getMovableType()

const String& Ogre::v1::Entity::getMovableType | ( | void |  | ) | const
| virtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNumManualLodLevels()

size_t Ogre::v1::Entity::getNumManualLodLevels | ( | void |  | ) | const

Returns the number of manual levels of detail that this entity supports.

Remarks
  This number never includes the original entity, it is difference with Mesh::getNumLodLevels.

## ◆ getNumSubEntities()

size_t Ogre::v1::Entity::getNumSubEntities | ( | void |  | ) | const

Retrieves the number of SubEntity objects making up this entity.

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeleton()

OldSkeletonInstance* Ogre::v1::Entity::getSkeleton | ( | void |  | ) | const
| inline

Get this Entity's personal skeleton instance.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getSkeletonInstanceSharingSet()

const EntitySet* Ogre::v1::Entity::getSkeletonInstanceSharingSet | ( |  | ) | const
| inline

Returns a pointer to the set of entities which share a OldSkeletonInstance.

If this instance does not share it's OldSkeletonInstance with other instances `NULL` will be returned

## ◆ getSkipAnimationStateUpdate()

bool Ogre::v1::Entity::getSkipAnimationStateUpdate | ( |  | ) | const
| inline

Entity's skeleton's AnimationState will not be automatically updated when set to true.

Useful if you wish to handle AnimationState updates manually.

## ◆ getSoftwareAnimationNormalsRequests()

int Ogre::v1::Entity::getSoftwareAnimationNormalsRequests | ( | void |  | ) | const
| inline

Returns the number of requests that have been made for software animation of normals.

Remarks
  If non-zero, and getSoftwareAnimationRequests() also returns non-zero, then software animation of normals will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Currently it is not possible to force software animation of only normals. Consequently this value is always less than or equal to that returned by getSoftwareAnimationRequests(). Requests for software animation of normals are made by calling the addSoftwareAnimationRequest() method with 'true' as the parameter.

## ◆ getSoftwareAnimationRequests()

int Ogre::v1::Entity::getSoftwareAnimationRequests | ( | void |  | ) | const
| inline

Returns the number of requests that have been made for software animation.

Remarks
  If non-zero then software animation will be performed in updateAnimation regardless of the current setting of isHardwareAnimationEnabled or any internal optimise for eliminate software animation. Requests for software animation are made by calling the addSoftwareAnimationRequest() method.

## ◆ getSubEntity() [1/4]

SubEntity* Ogre::v1::Entity::getSubEntity | ( | const String & | name | ) |

Gets a pointer to a SubEntity by name.

Remarks
  Names should be initialized during a Mesh creation.

## ◆ getSubEntity() [2/4]

const SubEntity* Ogre::v1::Entity::getSubEntity | ( | const String & | name | ) | const

## ◆ getSubEntity() [3/4]

SubEntity* Ogre::v1::Entity::getSubEntity | ( | size_t | index | ) |

Gets a pointer to a SubEntity, ie a part of an Entity.

## ◆ getSubEntity() [4/4]

const SubEntity* Ogre::v1::Entity::getSubEntity | ( | size_t | index | ) | const

## ◆ getTypeFlags()

uint32 Ogre::v1::Entity::getTypeFlags | ( | void |  | ) | const

Override to return specific type flag.

## ◆ getUpdateBoundingBoxFromSkeleton()

bool Ogre::v1::Entity::getUpdateBoundingBoxFromSkeleton | ( |  | ) | const
| inline

If true, the skeleton of the entity will be used to update the bounding box for culling.

Useful if you have skeletal animations that move the bones away from the root. Otherwise, the bounding box of the mesh in the binding pose will be used.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVertexDataForBinding()

VertexData* Ogre::v1::Entity::getVertexDataForBinding | ( | bool | casterPass | ) |

Retrieve the VertexData which should be used for GPU binding.

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ hasAnimationState()

bool Ogre::v1::Entity::hasAnimationState | ( | const String & | name | ) | const

Returns whether the AnimationState with the given name exists.

## ◆ hasEdgeList()

bool Ogre::v1::Entity::hasEdgeList | ( | void |  | ) |

## ◆ hasSkeleton()

bool Ogre::v1::Entity::hasSkeleton | ( | void |  | ) | const
| inline

Returns whether or not this entity is skeletally animated.

## ◆ hasVertexAnimation()

bool Ogre::v1::Entity::hasVertexAnimation | ( | void |  | ) | const

Returns whether or not this entity is either morph or pose animated.

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isHardwareAnimationEnabled()

bool Ogre::v1::Entity::isHardwareAnimationEnabled | ( | void |  | ) |

Returns whether or not hardware animation is enabled.

Remarks
  Because fixed-function indexed vertex blending is rarely supported by existing graphics cards, hardware animation can only be done if the vertex programs in the materials used to render an entity support it. Therefore, this method will only return true if all the materials assigned to this entity have vertex programs assigned, and all those vertex programs must support 'includes_morph_animation true' if using morph animation, 'includes_pose_animation true' if using pose animation and 'includes_skeletal_animation true' if using skeletal animation.

Also note the the function returns value according to the current active scheme. This is due to the fact that RTSS schemes may be different in their handling of hardware animation.

## ◆ isInitialised()

bool Ogre::v1::Entity::isInitialised | ( | void |  | ) | const
| inline

Has this Entity been initialised yet?

Remarks
  If this returns false, it means this Entity hasn't been completely constructed yet from the underlying resources (Mesh, Skeleton), which probably means they were delay-loaded and aren't available yet. This Entity won't render until it has been successfully initialised, nor will many of the manipulation methods function.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible()

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ loadingComplete()

virtual void Ogre::Resource::Listener::loadingComplete | ( | Resource * |  | ) |
| inlinevirtualinherited

Called whenever the resource finishes loading.

Remarks
  If a Resource has been marked as background loaded (

See also
  Resource::setBackgroundLoaded), the call does not itself occur in the thread which is doing the loading; when loading is complete a response indicator is placed with the ResourceGroupManager, which will then be sent back to the listener as part of the application's primary frame loop thread.

Reimplemented in Ogre::GpuProgramUsage.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ preparingComplete()

virtual void Ogre::Resource::Listener::preparingComplete | ( | Resource * |  | ) |
| inlinevirtualinherited

Called whenever the resource finishes preparing (paging into memory).

Remarks
  If a Resource has been marked as background loaded (

See also
  Resource::setBackgroundLoaded) the call does not itself occur in the thread which is doing the preparing; when preparing is complete a response indicator is placed with the ResourceGroupManager, which will then be sent back to the listener as part of the application's primary frame loop thread.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ refreshAvailableAnimationState()

void Ogre::v1::Entity::refreshAvailableAnimationState | ( | void |  | ) |

Updates the internal animation state set to include the latest available animations from the attached skeleton.

Remarks
  Use this method if you manually add animations to a skeleton, or have linked the skeleton to another for animation purposes since creating this entity.

Note
  If you have called getAnimationState prior to calling this method, the pointers will still remain valid.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeSoftwareAnimationRequest()

void Ogre::v1::Entity::removeSoftwareAnimationRequest | ( | bool | normalsAlso | ) |

Removes a request for software animation.

Remarks
  Calling this decrements the entity's internal counter of the number of requests for software animation. If the counter is already zero then calling this method throws an exception. The 'normalsAlso' flag if set to 'true' will also decrement the internal counter of number of requests for software animation of normals.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ setAlwaysUpdateMainSkeleton()

void Ogre::v1::Entity::setAlwaysUpdateMainSkeleton | ( | bool | update | ) |
| inline

The skeleton of the main entity will be updated even if the an LOD entity is being displayed.

useful if you have entities attached to the main entity. Otherwise position of attached entities will not be updated.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setDatablock() [1/2]

void Ogre::v1::Entity::setDatablock | ( | HlmsDatablock * | datablock | ) |

Sets the given HLMS datablock to all SubEntities.

## ◆ setDatablock() [2/2]

void Ogre::v1::Entity::setDatablock | ( | IdString | datablockName | ) |

Sets the given HLMS datablock to all SubEntities.

## ◆ setDatablockOrMaterialName()

void Ogre::v1::Entity::setDatablockOrMaterialName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |

Sets the material to use for the whole of this Item.

Remarks
  This is a shortcut method to set all the materials for all subentities of this Item. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubItem() and call the same method on the individual SubItem.

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setDisplaySkeleton()

void Ogre::v1::Entity::setDisplaySkeleton | ( | bool | display | ) |

Tells the Entity whether or not it should display it's skeleton, if it has one.

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setMaterial()

void Ogre::v1::Entity::setMaterial | ( | const MaterialPtr & | material | ) |

Sets the material to use for the whole of this entity.

Remarks
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

## ◆ setMaterialName()

void Ogre::v1::Entity::setMaterialName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME`
| ) |  |

Sets the material to use for the whole of this entity.

Remarks
  This is a shortcut method to set all the materials for all subentities of this entity. Only use this method is you want to set the same material for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setPolygonModeOverrideable()

void Ogre::v1::Entity::setPolygonModeOverrideable | ( | bool | PolygonModeOverrideable | ) |

Sets whether the polygon mode of this entire entity may be overridden by the camera detail settings.

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

void Ogre::v1::Entity::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtual

Reimplemented from Ogre::MovableObject.

## ◆ setRenderQueueSubGroup()

void Ogre::v1::Entity::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |

Sets the RenderQueue subgroup ID for the whole of this entity.

Remarks
  This is a shortcut method to set all the subgroups for all subentities of this entity. Only use this method is you want to set the same subgroup for all subentities or if you know there is only one. Otherwise call getSubEntity() and call the same method on the individual SubEntity.

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setSkipAnimationStateUpdate()

void Ogre::v1::Entity::setSkipAnimationStateUpdate | ( | bool | skip | ) |
| inline

Entity's skeleton's AnimationState will not be automatically updated when set to true.

Useful if you wish to handle AnimationState updates manually.

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setUpdateBoundingBoxFromSkeleton()

void Ogre::v1::Entity::setUpdateBoundingBoxFromSkeleton | ( | bool | update | ) |

If true, the skeleton of the entity will be used to update the bounding box for culling.

Useful if you have skeletal animations that move the bones away from the root. Otherwise, the bounding box of the mesh in the binding pose will be used.

Remarks
  When true, the bounding box will be generated to only enclose the bones that are used for skinning. Also the resulting bounding box will be expanded by the amount of GetMesh()->getBoneBoundingRadius(). The expansion amount can be changed on the mesh to achieve a better fitting bounding box.

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ shareSkeletonInstanceWith()

void Ogre::v1::Entity::shareSkeletonInstanceWith | ( | Entity * | entity | ) |

Shares the OldSkeletonInstance with the supplied entity.

Note that in order for this to work, both entities must have the same Skeleton.

## ◆ sharesSkeletonInstance()

bool Ogre::v1::Entity::sharesSkeletonInstance | ( |  | ) | const
| inline

Returns whether this entity shares it's SkeltonInstance with other entity instances.

## ◆ stopSharingSkeletonInstance()

void Ogre::v1::Entity::stopSharingSkeletonInstance | ( |  | ) |

Stops sharing the OldSkeletonInstance with other entities.

## ◆ unloadingComplete()

virtual void Ogre::Resource::Listener::unloadingComplete | ( | Resource * |  | ) |
| inlinevirtualinherited

Called whenever the resource has been unloaded.

Reimplemented in Ogre::GpuProgramUsage.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## Friends And Related Function Documentation

## ◆ EntityFactory

friend class EntityFactory
| friend

## ◆ SubEntity

friend class SubEntity
| friend

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreEntity.h